Package org.optaplanner.core.impl.score.stream.drools.tri

## Class DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>
      - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- All Implemented Interfaces:
    `ConstraintStream`, `TriConstraintStream<NewA,​NewB,​NewC>`, `InnerTriConstraintStream<NewA,​NewB,​NewC>`

      public final class DroolsGroupingTriConstraintStream<Solution_,​NewA,​NewB,​NewC>
      extends DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiFunction<A,​B,​NewC> groupKeyCMapping)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiConstraintCollector<A,​B,​?,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiConstraintCollector<A,​B,​?,​NewB> collectorB, BiConstraintCollector<A,​B,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiConstraintCollector<A,​B,​?,​NewA> collectorA, BiConstraintCollector<A,​B,​?,​NewB> collectorB, BiConstraintCollector<A,​B,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadConstraintCollector<A,​B,​C,​D,​?,​NewA> collectorA, QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB, QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriFunction<A,​B,​C,​NewC> groupKeyCMapping)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriConstraintCollector<A,​B,​C,​?,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, Function<A,​NewC> groupKeyCMapping)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, UniConstraintCollector<A,​?,​NewC> collector)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, UniConstraintCollector<A,​?,​NewB> collectorB, UniConstraintCollector<A,​?,​NewC> collectorC)` |
    `DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, UniConstraintCollector<A,​?,​NewA> collectorA, UniConstraintCollector<A,​?,​NewB> collectorB, UniConstraintCollector<A,​?,​NewC> collectorC)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `TriLeftHandSide<NewA,​NewB,​NewC>` | `getLeftHandSide()` |
    `boolean` | `guaranteesDistinct()` | This method will return true if the constraint stream is guaranteed to only produce distinct tuples.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `filter, flattenLast, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join, map`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, getChildStreams, getConstraintFactory`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.tri.InnerTriConstraintStream

      `distinct, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.tri.TriConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                   UniConstraintCollector<A,​?,​NewA> collectorA,
                                                   UniConstraintCollector<A,​?,​NewB> collectorB,
                                                   UniConstraintCollector<A,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                   BiConstraintCollector<A,​B,​?,​NewA> collectorA,
                                                   BiConstraintCollector<A,​B,​?,​NewB> collectorB,
                                                   BiConstraintCollector<A,​B,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewA> collectorA,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                   Function<A,​NewA> groupKeyAMapping,
                                                   UniConstraintCollector<A,​?,​NewB> collectorB,
                                                   UniConstraintCollector<A,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                   BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                   BiConstraintCollector<A,​B,​?,​NewB> collectorB,
                                                   BiConstraintCollector<A,​B,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                   TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                   QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewB> collectorB,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collectorC)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                   Function<A,​NewA> groupKeyAMapping,
                                                   Function<A,​NewB> groupKeyBMapping,
                                                   UniConstraintCollector<A,​?,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                   BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                   BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                   BiConstraintCollector<A,​B,​?,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                   TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                   TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                   TriConstraintCollector<A,​B,​C,​?,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                   QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                   QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                   QuadConstraintCollector<A,​B,​C,​D,​?,​NewC> collector)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                   Function<A,​NewA> groupKeyAMapping,
                                                   Function<A,​NewB> groupKeyBMapping,
                                                   Function<A,​NewC> groupKeyCMapping)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                   BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                   BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                   BiFunction<A,​B,​NewC> groupKeyCMapping)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                   TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                   TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                   TriFunction<A,​B,​C,​NewC> groupKeyCMapping)

    - #### DroolsGroupingTriConstraintStream

          public DroolsGroupingTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                   DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                   QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                   QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                   QuadFunction<A,​B,​C,​D,​NewC> groupKeyCMapping)

  - ### Method Detail

    - #### guaranteesDistinct

          public boolean guaranteesDistinct()

      Description copied from interface: `InnerTriConstraintStream`
      This method will return true if the constraint stream is guaranteed to only produce distinct tuples. See `InnerTriConstraintStream.distinct()` for details.
      Returns:
        true if the guarantee of distinct tuples is provided

    - #### getLeftHandSide

          public TriLeftHandSide<NewA,​NewB,​NewC> getLeftHandSide()

      Specified by:
        `getLeftHandSide` in class `DroolsAbstractTriConstraintStream<Solution_,​NewA,​NewB,​NewC>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`